{-# LANGUAGE ScopedTypeVariables, ViewPatterns, FlexibleInstances, FlexibleContexts, UndecidableInstances #-}
module Dpfs.SimpCnf (Fresh,fastcnfInt,pcnf)where

import Data.List
import Dpfs.Parser (Pexpr(..))

-- Replacement fpr the n+k pattern for ghc > 6.8
np :: (Num a, Ord a) => a -> a -> Maybe a
np k n | k <= n = Just (n-k)
       | otherwise = Nothing

class  Ord a => Fresh a where
     freshnames :: a -> [a]
     freshtrenn :: a

instance (Show a,Fresh a) => Fresh [a]
    where freshnames x = 
           let nn = [[freshtrenn,a,b] | a <- freshnames (head x), b <- freshnames (head x)]
             in  map (\y -> x ++ y) nn 
          freshtrenn = error "freshtrenn unsed for lists"       

instance Fresh Int
    where freshnames x = map (\y -> x + y) [1..10000]      --  vorher 100 
          freshtrenn = 0
          
instance Fresh (Int,[Int])
    where freshnames (x,z) = map (\y -> ( (x + y),z)) [1..10000]      --  vorher 100 
          --freshtrenn = 0          
             
instance Fresh Char
    where freshnames x = ['0'..'9']++['a'..'z']++['A'..'Z']
          freshtrenn = '_'       

{- | Add documentation here
-}         
fastcnfInt :: (Ord a, Fresh a,Show a) => Pexpr a -> Pexpr a
fastcnfInt expr = 
    let names = getnames expr 
        maxname = maximum names
        freshn = freshnames maxname
        (expr1,pairs) =  fastcnfFlat expr freshn
        addformel = map (\(n,e) -> Pequiv e (Pvar n)) pairs 
       in if pairs == [] 
          then expr1
          else Pand (expr1:addformel)

{- | Add documentation here
-}  
fastcnfFlat :: (Show name,Eq name) => Pexpr name -> [name] -> (Pexpr name, [(name,Pexpr name)])        
fastcnfFlat expr freshn = 
   if fastdepth expr > 4 then 
      fastcnfFlatR  expr [] [] freshn 
   else (expr,[])

{- | Add documentation here
-}  
fastcnfFlatR :: (Show name,Eq name) => Pexpr name -> [(name,Pexpr name)] -> [(name,Pexpr name)] -> [name] -> (Pexpr name, [(name,Pexpr name)])     
fastcnfFlatR  topexpr badpairs pairs [] =  error "fastcnfFlatR: too few names" 
fastcnfFlatR  topexpr badpairs pairs (fname:freshnrest) =  
  let      topdepth = fastdepth topexpr 
           (name,expr,resTopexpr) = getJust (fastreplaceone 4 topexpr fname) "fastcnfFlatR"
           (newbadpairs,newpairs) = if fastdepth expr > 4 then (((name,expr):badpairs),pairs)
                                    else (badpairs,(name,expr):pairs)
         in
 --             if badpairs /= [] then error ("fastcnfFlatR" ++ show (topdepth,topexpr,badpairs,pairs))
 --              else
          if topdepth > 4 
          then fastcnfFlatR  resTopexpr newbadpairs  newpairs freshnrest
          else fastcnfFlatRB  topexpr badpairs pairs (fname:freshnrest)
          
fastcnfFlatRB  topexpr badpairs pairs [] =  error "fastcnfFlatR: too few names"              
fastcnfFlatRB  topexpr [] pairs (name:freshnrest) = (topexpr,pairs)  
fastcnfFlatRB  topexpr ((badname1,badexpr1):badexprrest) pairs (fname:freshnrest) =   
  let Just (name,expr,badresexpr) = fastreplaceone 4 badexpr1 fname
      (topbads0,pairs0) = if fastdepth expr > 4 then ((name,expr):badexprrest,pairs)
                          else (badexprrest, ((name,expr):pairs))
      (topbads1,pairs1) = if fastdepth badresexpr > 4 then ((badname1,badresexpr):topbads0,pairs0)
                 else (topbads0, (badname1,badresexpr): pairs0)
    in fastcnfFlatRB  topexpr topbads1 pairs1 freshnrest               


{- | Add documentation here
-}  
---    Just gibt zurueck  (name,exprOfName,topexpr)
fastreplaceone:: (Show name,Eq name) => Int-> (Pexpr name) -> name -> Maybe (name,(Pexpr name),(Pexpr name))
fastreplaceone 0 expr name = Just (name,expr,Pvar name)
fastreplaceone (np 1 -> Just n) Ptrue name = Nothing
fastreplaceone (np 1 -> Just n) Pfalse name = Nothing
fastreplaceone (np 1 -> Just n) (Pvar x) name = Nothing
fastreplaceone (np 1 -> Just n) (Pnot e) name = 
     let eneu = fastreplaceone n e name 
       in case eneu of Nothing -> Nothing
                       Just (name1,exprOfName,eneu1) -> Just (name1, exprOfName, Pnot eneu1) 
fastreplaceone (np 1 -> Just n) (Por e) name = 
 --    if True then error ("fastreplaceone Por " ++ show e) else
     let mdepth = maximum (map fastdepth e)
         Just (e1,erest) = fastsplit e mdepth
         eneu = fastreplaceone n e1 name 
       in if n >  mdepth 
          then Nothing 
          else 
             case eneu of Nothing -> Nothing
                          Just (name,exprOfName, topexpr) -> Just (name,exprOfName, Por (topexpr : erest))

fastreplaceone (np 1 -> Just n) (Pand e) name = 
 --   if True then error ("fastreplaceone Pand  " ++ show e) else
     let mdepth = maximum (map fastdepth e)
         Just (e1,erest) = fastsplit e mdepth
         eneu = fastreplaceone n e1 name 
       in if n >  mdepth then Nothing 
           else 
             case eneu of Nothing -> Nothing
                          Just (name,exprOfName, topexpr) -> Just (name,exprOfName, Pand (topexpr : erest))                                                 
fastreplaceone (np 1 -> Just n) (Pimpl e f) name = 
 --  if True then error ("fastreplaceone Pimpl " ++ show e) else
     let edepth = fastdepth e
         fdepth = fastdepth f
         mdepth = max edepth fdepth
         eneu = fastreplaceone n e name 
         fneu = fastreplaceone n f name  
       in if n >  mdepth then Nothing 
           else 
            if edepth == mdepth 
            then  case eneu of Nothing -> Nothing
                               Just (name,exprOfName, topexpr) -> Just (name,exprOfName, Pimpl  topexpr f)
            else  case fneu of Nothing -> Nothing
                               Just (name,exprOfName, topexpr) -> Just (name,exprOfName, Pimpl  e topexpr)              

fastreplaceone (np 1 -> Just n) (Pequiv e f) name =  
 --  if True then error ("fastreplaceone Pequiv " ++ show (e,f,name)) else
     let edepth = fastdepth e
         fdepth = fastdepth f
         mdepth = max edepth fdepth
         eneu = fastreplaceone n e name 
         fneu = fastreplaceone n f name  
       in 
 --        if True then error ("fastreplaceone Pequiv " ++ show (edepth,fdepth,n,mdepth,name)) else
           if n >  mdepth then Nothing 
           else 
            if edepth == mdepth 
            then  case eneu of Nothing -> Nothing
                               Just (name,exprOfName, topexpr) -> Just (name,exprOfName, Pequiv  topexpr f)
            else  case fneu of Nothing -> Nothing
                               Just (name,exprOfName, topexpr) -> Just (name,exprOfName, Pequiv  e topexpr)                               

{- | Add documentation here
-}  
fastsplit [] m = Nothing
fastsplit (e:es) m = let mde = fastdepth e
                         res = fastsplit es m
                    in if mde < m then  
                       case res of Nothing -> Nothing
                                   Just (e1,er) -> Just (e1,e:er)
                       else Just (e,es)
{- | Add documentation here
-}                        
fastdepth Ptrue = 0
fastdepth Pfalse = 0
fastdepth (Pvar x) = 0
fastdepth (Pnot e)  = 1 + (fastdepth e)
fastdepth (Por e)  = 1 + (maximum (map fastdepth e))
fastdepth (Pand e)  = 1 + (maximum (map fastdepth e))
fastdepth (Pequiv e f)  = 1 + (max (fastdepth e) (fastdepth f) )
fastdepth (Pimpl e f)  = 1 + (max (fastdepth e) (fastdepth f) )

{- | Add documentation here
-}  
getnames :: Eq a => Pexpr a -> [a]
getnames  e =   nub (getnamesr e)
--getnames  e =   let res = nub (getnamesr e) 
 --                in  error ("getnames:  " ++(show e) ++ "  res  " ++  (show res))
getnamesr Ptrue = []
getnamesr Pfalse = []
getnamesr (Pvar x) = [x]
getnamesr (Pand es) =  concat (map getnamesr es) 
getnamesr (Por es) =  concat (map getnamesr es) 
getnamesr (Pimpl e f) = concat (map getnamesr [e,f]) 
getnamesr  (Pequiv e f) = concat (map getnamesr [e,f]) 
getnamesr (Pnot e) =  getnamesr e

addPnot formel = Pnot formel

getJust xs tx = case xs of Nothing -> error ("getJust " ++tx) 
                           Just res -> res
---   Ende schnelle cnf

-- pcnf --

pcnf :: (Ord a, Show a) => Pexpr a -> Pexpr a
pcnf = interncnf

--  Annahme: flattened rein
--  interncnf ::  Pexpr String -> Pexpr String
interncnf :: (Ord a, Show a) => Pexpr a -> Pexpr a
interncnf Ptrue = Ptrue             
interncnf Pfalse = Pfalse
interncnf (Pnot x) = Pand [Por [(Pnot x)]] 
interncnf (Pvar x) = Pand [Por [(Pvar x)]] 
interncnf (Por xs) = if (all (scPistliteral) xs) then Pand [Por (sort xs)]
                     else 
                       let cslist = map interncnf xs
                  ---      in  error ("interncnftest-Por: " ++ show cslist)
                        in  (interncnfPorInsert cslist) 
                        
interncnf (Pand xs) = if (all scPistliteral xs) 
                 then Pand (sort (map (\x -> Por [x]) xs))
                 else if scIstklauselemenge (Pand xs) 
                 then cnfsort (Pand xs)
                 else 
                    let clist = concatMap (\x ->  selPand (interncnf x))   xs
                     in Pand (interncnfPandInsert clist)  

interncnfPorInsert :: (Ord a, Show a) => [Pexpr a] -> Pexpr a
interncnfPorInsert (cs:cslist) =  interncnfPorInsertR cslist cs 
interncnfPorInsertR [] cs  = cs
interncnfPorInsertR (cs1:cslist) cs =
    --   error ("interncnfPorInsertR: " ++ show (cs1,cs,combinePorScnfs cs1 cs))
         interncnfPorInsertR  cslist  (combinePorScnfs cs1 cs)
    

interncnfPandInsert xs  = interncnfPandInsertR xs []
interncnfPandInsertR [] res = res
interncnfPandInsertR (c:cs) res = 
    let resneu = insert  c res
    in interncnfPandInsertR cs resneu 

                                            
selPand (Pand xs) = xs
selPand (Pand xs) = error ("selPand: " ++ show xs)
---  
--- Funktionen fuer cnfs: 
cnfsort (Pand clist) = 
      let res1 = map cnfPorsort clist 
       in Pand (sort res1)
cnfPorsort (Por llist) = Por (sort llist)

--- Funktionen fuer sortierte cnfs:         

combinePorScnfs (Pand clist1) (Pand clist2)  =
   let pairlist = [(x,y) | x <- clist1, y <- clist2]
   in Pand (insertScnf pairlist [])        

insertScnf [] res = res
insertScnf ((c,d): restlist) res =
   let cneu = clMerge c d 
       resneu = if (cneu `elem` res  || cTaut cneu)
                then res
                else insert  cneu res
   in insertScnf restlist  resneu
                
clMerge (Por l1)  (Por l2)  = Por (clMerger  l1 l2) 
clMerger  [] l2       = l2
clMerger  l1 []       = l1
clMerger  (x:l1)  (y:l2) =  
         if x < y then x : clMerger   l1   (y:l2)  
         else if x == y then  x : clMerger   l1    l2 
         else if y < x then y : clMerger   (x:l1)    l2 
         else error ("clMerger Fehler: " ++ (show (x,l1,y,l2)))   
 
--insertClauseinScnf cl (Pand clist) = 
--       Pand (insertClauseinScnfR cl clist)

insertClauseinScnfR x [] = [x]
insertClauseinScnfR x (y:ys) = if x < y then x : (y:ys)
                               else if x == y then y:ys 
                               else y:  insertClauseinScnfR x ys
                               
-- ENDE pcnf--                               

scPistliteral :: (Ord a, Show a) => Pexpr a -> Bool
scPistliteral  Ptrue = True 
scPistliteral Pfalse = True
scPistliteral (Pvar x) = True
scPistliteral (Pnot (Pvar x)) = True
scPistliteral _ = False

scIstklausel (Por xs) = all (scPistliteral) xs 
scIstklausel _   = False
scIstklauselemenge (Pand xs) = 
       all (\xss -> scIstklausel xss) xs
scIstklauselemenge _  = False  

cTaut (Por cl)   =  (cl ==  [Ptrue]) || cTautr cl cl 
--  cnfIsTaut cl   =  cTautr cl cl    --  vor Maerz 2008
cTautr [] cl = False
cTautr ((Pnot (Pvar x)):clr) cl = ((Pvar x) `elem` cl) ||  cTautr  clr  cl 
cTautr (_:clr) cl =  cTautr  clr  cl 